unit hiPascalScript;

interface

uses kol,windows,Share,Debug,pascalc,pasfunc;

type
  THIPascalScript = class(TDebug)
   private
    FStr,substr:string;
    FDataCount:integer;
    R:TVar;
    Calc:TPasCalc;
    function TestRep(P:integer):boolean;
    procedure SetCount(Value:integer);      
   public
    Str:array of THI_Event;
    _prop_PasScript:string;

    _event_onErr:THI_Event;
    _event_onVarName:THI_Event;
    _event_onRes:THI_Event;
    constructor Create;
    destructor Destroy; override;
    procedure Init;
    procedure _work_doCall(var _Data:TData; Index:word);
    procedure _work_doScript(var _Data:TData; Index:word);
    procedure _work_doStop(var _Data:TData; Index:word);
    property _prop_DataCount:integer write SetCount;
    procedure _var_VarName(var _Data:TData; Index:word);
    procedure _var_Value(var _Data:TData; Index:word);
    procedure _var_Type(var _Data:TData; Index:word); 
  end;

implementation

procedure ProcessProc;
begin
  // Perform messages processing
  Applet.ProcessMessages;
end;

{
function VarIsString(V : variant) : boolean;
var t: integer;
begin
  t := VarType(V);
  Result := (t=varString) or (t=varOleStr);
end;
}

function VarTypeName(V : variant) : string;
var i : integer;
begin
  i := VarType(v);

  case i of
    varEmpty    : Result := 'Empty';
    varNull     : Result := 'Null';
    varSmallint : Result := 'SmallInt';
    varInteger  : Result := 'Integer';
    varSingle   : Result := 'Single';
    varDouble   : Result := 'Double';
    varCurrency : Result := 'Currency ';
    varDate     : Result := 'Date';
    varOleStr   : Result := 'OleStr';
    varDispatch : Result := 'Dispatch';
    varError    : Result := 'Error';
    varBoolean  : Result := 'Boolean';
    varVariant  : Result := 'Variant';
    varUnknown  : Result := 'Unknown';
    varByte     : Result := 'Byte';
    varString   : Result := 'String';
    varTypeMask : Result := 'TypeMask';
    varArray    : Result := 'Array';
    else Result := '';
  end;
end;


constructor THIPascalScript.Create;
begin
  inherited  Create;  
  InitAdd(Init);
end;

destructor THIPascalScript.Destroy;
begin
  Calc.Free; 
  inherited Destroy;
end;


procedure THIPascalScript.Init;
begin
  // Create TPasCalc instance
  Calc := TPasCalc.Create;
  // Register idle procedure (not required)
  Calc.SetProcessProc(@ProcessProc);
  // Register user-defined functions from module pasfunc.pas
  SetFunctions(Calc);
end;


procedure THIPascalScript.SetCount;
begin
   SetLength(Str,Value);
   FDataCount := Value;
end;

function THIPascalScript.TestRep(P:integer):boolean;
begin
  Result :=  not (FStr[P+length(substr)] in ['0'..'9']);
end;


procedure THIPascalScript._work_doCall;
var i:integer;
    //s : string;
begin

  FStr := _prop_PasScript;
  Replace(FStr,'%%',#0);
  for i := 1 to FDataCount do begin
    substr := '%'+int2str(i);
    Replace(FStr,substr,#1+ReadString(_Data,Str[i-1]),TestRep);
  end;
  Replace(FStr,#1,'');
  Replace(FStr,#0,'%');
 
  // Reset variable list
  Calc.ClearVars;
  // Execite script
  Calc.Execute(FStr);
  // Display execution errors (if any)
  if Calc.ErrCode<>0 then
  begin
    _hi_OnEvent(_event_onErr, Calc.ErrMsg);
    _hi_OnEvent(_event_onErr, Calc.ErrLine);
  end;
  
  // Display variables
  for i := 0 to Calc.VarCount-1 do
  begin
    Calc.VarByIndex(i,R);
    
    _hi_OnEvent(_event_onVarName, String(R.Name));
   
  case VarType(R.Value) of
    varBoolean  : begin 
                    if R.Value then _hi_OnEvent(_event_onRes, 1)
                    else _hi_OnEvent(_event_onRes, 0);
                  end;
    varNull     : _hi_OnEvent(_event_onRes, '');
    varSmallint : _hi_OnEvent(_event_onRes, Integer(R.Value));
    varInteger  : _hi_OnEvent(_event_onRes, Integer(R.Value));
    varSingle   : _hi_OnEvent(_event_onRes, Real(R.Value));
    varDouble   : _hi_OnEvent(_event_onRes, Real(R.Value));
    varCurrency : _hi_OnEvent(_event_onRes, Real(R.Value));
    varDate     : _hi_OnEvent(_event_onRes, Real(R.Value));
    varByte     : _hi_OnEvent(_event_onRes, Integer(R.Value));
    varString   : _hi_OnEvent(_event_onRes, String(R.Value));
    else  _hi_OnEvent(_event_onRes, '');
  end;    
  end;       
end;



procedure THIPascalScript._work_doScript;
begin
  _prop_PasScript := ToString(_Data);
end;

procedure THIPascalScript._work_doStop;
begin
  // Break execution
  Calc.Stop := True;
end;

procedure THIPascalScript._var_VarName;
begin
  dtString(_Data, R.Name);
end;

procedure THIPascalScript._var_Value;
begin
  dtString(_Data, R.Value);
end;

procedure THIPascalScript._var_Type;
begin
  dtString(_Data,VarTypeName(R.Value));
end;

end.
